Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/AlgorithmConverter.cs	(revision 9215)
@@ -0,0 +1,76 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using Newtonsoft.Json.Linq;
+
+namespace HeuristicLab.Services.Optimization.ControllerService.Parsers {
+  public static class AlgorithmConverter {
+
+    public static Algorithm Convert(string json) {
+      var algorithm = new Algorithm();
+      var o = JObject.Parse(json);
+      foreach (JProperty param in o["Algorithm Parameters"]) {
+        Parameter parameter = CreateParameter(param);
+        algorithm.Parameters.Items.Add(parameter);
+      }
+
+      var problemParams = o["Problem Parameters"];
+      // TODO: Store problem parameters
+      if (problemParams != null) {
+        algorithm.Problem = new Problem();
+        foreach (JProperty param in problemParams) {
+          Parameter parameter = CreateParameter(param);
+          algorithm.Problem.Parameters.Items.Add(parameter);
+        }
+      }
+      return algorithm;
+    }
+
+    public static Algorithm ConvertAppend(string json, Algorithm algorithm) {
+      var o = JObject.Parse(json);
+      foreach (JProperty param in o["Algorithm Parameters"]) {
+        Parameter parameter = CreateParameter(param);
+        var oldParameter = (from p in algorithm.Parameters.Items where p.Value.Name == parameter.Value.Name select p).FirstOrDefault();
+        if (oldParameter != null) {
+          oldParameter.Value = parameter.Value;
+        }
+        else {
+          algorithm.Parameters.Items.Add(parameter);
+        }
+      }
+
+      var problemParams = o["Problem Parameters"];
+      if (problemParams != null) {
+        algorithm.Problem = new Problem();
+        foreach (JProperty param in problemParams) {
+          Parameter parameter = CreateParameter(param);          
+          var oldParameter = (from p in algorithm.Problem.Parameters.Items where p.Value.Name == parameter.Value.Name select p).FirstOrDefault();
+          if (oldParameter != null) {
+            oldParameter.Value = parameter.Value;
+          }
+          else {
+            algorithm.Problem.Parameters.Items.Add(parameter);
+          }
+        }
+      }
+      return algorithm;
+    }
+
+    private static Parameter CreateParameter(JProperty property) {
+      JToken token = property.Value;
+      switch (token.Type) {
+        case JTokenType.Integer:
+        case JTokenType.Float:
+          return new Parameter() { Type = ParameterType.Decimal, Value = new DecimalValue() { Name = property.Name, Value = (double)property.Value } };
+        case JTokenType.Boolean:
+          return new Parameter() { Type = ParameterType.Boolean, Value = new BoolValue() { Name = property.Name, Value = (bool)property.Value } };
+        case JTokenType.String:
+          return new Parameter() { Type = ParameterType.Type, Value = new TypeValue() { Name = property.Name, Value = (string)property.Value } };                  
+        default:
+          throw new Exception("Unhandled datatype: " + property.Type);
+      }
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/ScenarioParser.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/ScenarioParser.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Parsers/ScenarioParser.cs	(revision 9215)
@@ -0,0 +1,316 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.IO;
+using System.Xml;
+using System.Globalization;
+using System.Xml.Linq;
+using HeuristicLab.Services.Optimization.ControllerService.Azure;
+using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+using System.Diagnostics;
+
+namespace HeuristicLab.Services.Optimization.ControllerService {
+  public class ScenarioParser {
+    private static IList<Model.OptimizationScenario> scenarios;
+    private static object lockable = new object();
+
+    private IDataAccessLayer dal = DataAccessLayerProvider.GetLayer();
+
+    public IList<Model.OptimizationScenario> Scenarios {
+      get {
+        if (scenarios == null) {
+          lock (lockable) {
+            if (scenarios == null) {
+              ParseScenarios();
+            }
+          }
+        }
+        return scenarios;
+      }
+    }
+    
+    public Model.OptimizationScenario GetByName(string name) {
+      foreach (var scen in Scenarios) {
+        if (scen.Id == name) {
+          return scen;
+        }
+      }
+      return null;
+    }
+
+    /*// http://www.sascha-dittmann.de/post/Webseitenpfade-einer-Windows-Azure-Web-Rolle-bestimmen.aspx
+    private static IEnumerable<string> WebSiteDirectories {
+      get {
+        var roleRootDir = Environment.GetEnvironmentVariable("RdRoleRoot");
+        if (roleRootDir == null)
+          return Enumerable.Empty<string>();
+        XNamespace roleModelNs =
+          "http://schemas.microsoft.com/ServiceHosting/2008/10/ServiceDefinition";
+        var roleModelDoc = XDocument.Load(Path.Combine(roleRootDir, "RoleModel.xml"));
+        if (roleModelDoc.Root == null)
+          return Enumerable.Empty<string>();
+
+        var sites = roleModelDoc.Root.Element(roleModelNs + "Sites");
+        if (sites == null)
+          return Enumerable.Empty<string>();
+
+        var siteElements = sites.Elements(roleModelNs + "Site");
+
+        return
+          from siteElement in siteElements
+          where siteElement.Attribute("name") != null
+                && siteElement.Attribute("name").Value == "Web"
+                && siteElement.Attribute("physicalDirectory") != null
+          select Path.Combine(roleRootDir,
+                 siteElement.Attribute("physicalDirectory").Value);
+      }
+    }
+     */
+
+    private void ParseScenarios() {
+      var scens = new List<Model.OptimizationScenario>();
+      /*string path;
+      if (WebSiteDirectories.Count() != 0) {
+        path = WebSiteDirectories.FirstOrDefault() + @"\Mappings";
+      } else {
+        path = AppDomain.CurrentDomain.BaseDirectory + @"\Mappings";
+      }
+        
+      foreach (var file in Directory.EnumerateFiles(path, "*.xml")) {
+        var scenario = ParseScenarioFromFile(file);
+        if (scenario != null)
+          scens.Add(scenario);
+      }*/
+
+      var scenarioDao = dal.ScenarioDao;
+      var blobDao = dal.BlobDao;
+      foreach (var entity in scenarioDao.GetAllEntities()) {
+        var scenarioXml = blobDao.FindByKey(entity.Scenario).Text;
+        var scenario = ParseScenarioFromXml(scenarioXml);
+        if (scenario != null)
+          scens.Add(scenario);
+      }
+
+      scenarios = scens;
+    }
+
+    private XmlReaderSettings GetSettings() {
+      // Set the validation settings.
+      XmlReaderSettings settings = new XmlReaderSettings();
+      settings.ValidationType = ValidationType.Schema;
+      settings.Schemas.Add("urn:scenario-schema", AppDomain.CurrentDomain.BaseDirectory + @"\Mappings\scenario.xsd");      
+      return settings;
+    }
+
+    public Model.OptimizationScenario ParseScenarioFromXml(string xml) {
+      //using (var reader = XmlReader.Create(new StringReader(xml), GetSettings())) {
+        return ParseScenario(new StringReader(xml));
+      //}            
+    }
+
+   /* private Model.OptimizationScenario ParseScenarioFromFile(string filename) {
+      using (var reader = XmlReader.Create(new FileStream(filename, FileMode.Open), GetSettings())) {
+        return ParseScenario(reader);
+      }      
+    } */
+
+    private Model.Problem ParseProblem(XmlReader reader) {
+      var problem = new Model.Problem();
+      while (reader.Read()) {
+        if (reader.NodeType == XmlNodeType.EndElement)
+          break;
+        if (reader.Name == "parameters")
+          problem.Parameters.Items = ParseParameters(reader);
+      }
+      return problem;
+    }
+
+    private void ParseAlgorithms(out IList<Model.Algorithm> algos, XmlReader reader) {
+      algos = new List<Model.Algorithm>();
+      var depth = reader.Depth;
+      do {
+        if (reader.Name == "algorithm" && reader.Depth == depth) {
+          var innerAlg = new Model.Algorithm();
+          algos.Add(innerAlg);
+          
+          innerAlg.Mapper = reader.GetAttribute("mapper");
+          reader.Read();
+          for (;;) {
+            if (reader.Name == "algorithm" && reader.NodeType == XmlNodeType.EndElement)
+              break;
+
+            if (reader.Name == "parameters" && reader.NodeType == XmlNodeType.Element) {
+              innerAlg.Parameters.Items = ParseParameters(reader);
+              continue;
+            }
+            else if (reader.Name == "problem" && reader.NodeType == XmlNodeType.Element) {
+              innerAlg.Problem = ParseProblem(reader);
+              continue;
+            }
+            else if (reader.Name == "algorithm" && reader.NodeType == XmlNodeType.Element) {
+              IList<Model.Algorithm> childAlgos;
+              ParseAlgorithms(out childAlgos, reader);
+              innerAlg.ChildAlgorithms = childAlgos;
+              //TODO: Test with child algorithms
+              continue;
+            }
+            reader.Read();
+          }
+        }
+      } while (reader.Read() && reader.Depth >= depth);
+    }
+
+    private Model.OptimizationScenario ParseScenarioElement(XmlReader reader) {
+      var scenario = new Model.OptimizationScenario();
+      var depth = reader.Depth;
+      while (reader.Depth >= depth) {
+        if (reader.Name == "scenario" && reader.NodeType == XmlNodeType.EndElement)
+          break;
+
+        if (reader.Name == "name") {
+          scenario.Id = reader.ReadElementContentAsString();
+          continue;
+        }
+        else if (reader.Name == "algorithm") {
+          IList<Model.Algorithm> algos;
+          ParseAlgorithms(out algos, reader);
+          scenario.Algorithm = algos;
+          continue;
+        }
+        reader.Read();
+      }
+      return scenario;
+    }
+
+    private Model.OptimizationScenario ParseScenario(StringReader str) {
+      // Set the validation settings.      
+      bool isErrorPresent = false;
+      var settings = GetSettings();
+      settings.ValidationEventHandler += (sender, args) => {
+        Trace.WriteLine(args.Message);
+        isErrorPresent = true;
+      };
+      Model.OptimizationScenario scenario = null;      
+      using (var reader = XmlReader.Create(str, settings)) {        
+        while (!reader.EOF) {
+          if (reader.Name == "scenario" && reader.NodeType == XmlNodeType.Element) {
+            scenario = ParseScenarioElement(reader);            
+          }
+          reader.Read();
+        }
+      }
+      
+      if (isErrorPresent)
+        return null;
+      return scenario;
+    }
+
+    struct ValueEntry {
+      public double v1;
+      public double v2;
+    };
+
+    private void ParseDecimalMatrix(Model.DecimalMatrix matrix, XmlReader reader) {      
+      IList<ValueEntry> ventries = new List<ValueEntry>();
+      while (reader.Read()) {        
+        if (reader.Name == "param")
+          break;
+        if (reader.Name == "value") {
+          var val1 = Convert.ToDouble(reader.GetAttribute("v1"), CultureInfo.InvariantCulture.NumberFormat);
+          var val2 = Convert.ToDouble(reader.GetAttribute("v2"), CultureInfo.InvariantCulture.NumberFormat);
+          ventries.Add(new ValueEntry() { v1 = val1, v2 = val2 });          
+        }
+      }
+      double[][] mat = new double[ventries.Count][];
+      int i=0;
+      foreach (var entry in ventries) {
+        mat[i] = new double[2];
+        mat[i][0] = entry.v1;
+        mat[i][1] = entry.v2;
+        i++;
+      }
+      matrix.Value = mat;
+    }
+
+    private IList<Model.Parameter> ParseParameters(XmlReader reader) {
+      IList<Model.Parameter> parameters = new List<Model.Parameter>();
+      while (reader.Read()) {
+        if (reader.Name == "parameters" && reader.NodeType == XmlNodeType.EndElement)
+          break;
+        // parse parameter
+        if (reader.Name == "param" && reader.NodeType == XmlNodeType.Element) {
+          var param = new Model.Parameter();
+          var typeAtt = reader.GetAttribute("type");
+          param.Type = (Model.ParameterType)Enum.Parse(typeof(Model.ParameterType), typeAtt);
+          switch (param.Type) {
+            case Model.ParameterType.Boolean:
+              param.Value = new Model.BoolValue() { Name = reader.GetAttribute("name"), Value = Convert.ToBoolean(reader.GetAttribute("value")) };
+              break;
+            case Model.ParameterType.Integer:
+            case Model.ParameterType.Percent:
+            case Model.ParameterType.Decimal:
+              //TODO: Check which comma char is being used; enhance to use any
+              param.Value = new Model.DecimalValue() { Name = reader.GetAttribute("name"), Value = Convert.ToDouble(reader.GetAttribute("value"), CultureInfo.InvariantCulture.NumberFormat) };
+              break;            
+            case Model.ParameterType.DecimalMatrix:
+              var decMatrix = new Model.DecimalMatrix() { Name = reader.GetAttribute("name") };
+              ParseDecimalMatrix(decMatrix, reader);
+              param.Value = decMatrix;
+              break;
+            case Model.ParameterType.DecimalVector:
+              var decVec = new Model.DecimalVector() { Name = reader.GetAttribute("name") };
+              ParseDecimalVector(decVec, reader);
+              param.Value = decVec;
+              break;
+            case Model.ParameterType.Type:
+              var type = new Model.TypeValue() { Name = reader.GetAttribute("name") };
+              ParseType(type, reader);
+              param.Value = type;
+              break;
+            case Model.ParameterType.String:
+              param.Value = new Model.StringValue() { Name = reader.GetAttribute("name"), Value = reader.GetAttribute("value") };
+              break;
+            default:
+              Console.WriteLine("Unhandled model type: " + param.Type);
+              break;
+          }
+          parameters.Add(param);
+        }
+      }
+      return parameters;
+    }
+
+    private void ParseType(Model.TypeValue type, XmlReader reader) {
+      var choices = new List<string>();
+      string selected = null;
+      while (reader.Read()) {
+        if (reader.Name == "param")
+          break;
+        if (reader.Name == "choice") {
+          var choice = reader.GetAttribute("name");
+          if (reader.HasAttributes && Convert.ToBoolean(reader.GetAttribute("selected"))) {            
+            selected = choice;
+          }
+          choices.Add(choice);
+        }
+      }
+      type.Options = choices.ToArray();
+      type.Value = selected;
+    }
+
+    private void ParseDecimalVector(Model.DecimalVector decVec, XmlReader reader) {
+      var entries = new List<double>();
+      //IList<ValueEntry> ventries = new List<ValueEntry>();
+      while (reader.Read()) {
+        if (reader.Name == "param")
+          break;
+        if (reader.Name == "value") {
+          var val1 = Convert.ToDouble(reader.GetAttribute("v1"), CultureInfo.InvariantCulture.NumberFormat);
+          entries.Add(val1);
+        }
+      }
+      decVec.Value = entries.ToArray();      
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/PlaceholderControllerService.cs	(revision 9215)
@@ -69,6 +69,7 @@
     }
 
-    public void ScheduleOptimizationScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
+    public bool ScheduleOptimizationScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
       hiveManager.DispatchScenario(user, scenario, details);
+      return true;
     }
 
@@ -83,6 +84,6 @@
 
 
-    public void DeleteJob(Model.User user, string id) {
-      hiveManager.DeleteJob(user, id);
+    public bool DeleteJob(Model.User user, string id) {
+      return hiveManager.DeleteJob(user, id);
     }
 
@@ -117,4 +118,28 @@
               select e.Id).AsEnumerable();      
     }
+
+
+    public bool SaveExperiment(User user, Experiment experiment) {
+      return hiveManager.SaveExperiment(user, experiment);
+    }
+
+
+    public IEnumerable<string> GetExperiments(User user) {
+      return hiveManager.GetExperiments(user);
+    }
+
+
+    public bool DeleteExperiment(User user, string experiment) {
+      return hiveManager.DeleteExperiment(user, experiment);
+    }
+
+
+    public Job GetTasks(User u, string jobId) {
+      return hiveManager.GetTasks(u, jobId);
+    }
+
+    public Task GetTaskData(User u, string jobId, string taskId) {
+      return hiveManager.GetTaskData(u, jobId, taskId);
+    }
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/ExperimentSupport.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/ExperimentSupport.js	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/ExperimentSupport.js	(revision 9215)
@@ -0,0 +1,140 @@
+﻿function workInProgress(isWorking) {
+    var loader = $(".loader");
+    var submitButton = $(".submitter");
+    if (isWorking) {
+        loader.removeClass("unseen");
+        submitButton.attr("disabled", "disabled");
+    } else {
+        loader.addClass("unseen");
+        submitButton.removeAttr("disabled");
+    }
+}
+
+function log(arguments) {
+    if (window.console && console && console.log) {
+        if ($.isArray(arguments)) {
+            if ((Array.prototype.slice.call(arguments)).length == 1 && typeof Array.prototype.slice.call(arguments)[0] == 'string') {
+                var txt = (Array.prototype.slice.call(arguments)).toString();
+                console.log(txt);
+                return txt;
+            }
+            else {
+                var txt = Array.prototype.slice.call(arguments);
+                console.log(txt);
+                return txt;
+            }
+        } else {
+            console.log(arguments);
+            return arguments;
+        }
+    }
+}
+
+$(document).ready(function () {
+    var tree = $('#container').dynatree({
+        onActivate: function (node) {
+            if (node && node.data.title !== "Experiment") {
+                $('input[name="RemoveNode"]').removeAttr("disabled");
+            } else if (node) {
+                $('input[name="RemoveNode"]').attr("disabled", "disabled");
+            }
+        },
+        onDeactivate: function (node) {
+        },
+        dnd: {
+            autoExpandMS: 750,
+
+            onDragStart: function (node) {
+                return node.data.title !== "Experiment";
+            },
+            onDragEnter: function (node, sourceNode) {
+                return true;
+            },
+            onDragOver: function (node, sourceNode, hitMode) {
+                return node.data.title !== "Experiment" || hitMode === "over";
+            },
+            onDrop: function (node, sourceNode, hitMode, ui, draggable) {
+                if (sourceNode) {
+                    sourceNode.move(node, hitMode);
+                }
+                else {
+                    newNode = { title: draggable.element[0].id };
+                    if (hitMode == "over") {
+                        node.addChild(newNode);
+                        node.expand(true);
+                    }
+                    else if (hitMode == "before") {
+                        node.parent.addChild(newNode, node);
+                    }
+                    else {
+                        node.parent.addChild(newNode, node.getNextSibling());
+                    }
+                }
+            },
+            onDragLeave: function (node, sourceNode) {
+            }
+        }
+    });
+
+    $('.dragables').each(function () {
+        $(this).draggable({
+            revert: true,
+            connectToDynatree: true,
+            cursorAt: { top: -5, left: -5 },
+            helper: "clone"
+        });
+    });
+
+    $(".submitter").each(function () {
+        var btn = $(this);
+        $(this).click(function () {
+            workInProgress(true);
+            var name = $('input[name="Name"]').val();
+            var root = {
+                Experiment: $("#container").dynatree("getTree").toDict(),
+                Name: name
+            };
+            $.ajax({
+                type: "POST",
+                url: '/Experiment/Save',
+                contentType: "application/json; charset=utf-8",
+                dataType: "json",
+                data: JSON.stringify(root),
+                success: function (result) {
+                    log(result);
+                    if (result.success) {
+                        var clearers = $("#experiments .clearer");
+                        if (clearers && clearers.length > 0) {
+                            var experimentDiv = $('<div class="dragables" id="' + name + '"><p>' + name + '</p></div>').draggable({
+                                revert: true,
+                                connectToDynatree: true,
+                                cursorAt: { top: -5, left: -5 },
+                                helper: "clone"
+                            });
+                            experimentDiv.insertBefore("#experiments .clearer");
+                            //$(clearers[clearers.length - 1]).parent().before().append('<div class="dragables" id="' + name + '"><p>' + name + '</p></div>');
+                            log("Added new div to experiments");
+                            $("#jsonMessage").text("Saved experiment '" + result.data + "'!");
+                        }
+                    } else {
+                        $("#jsonMessage").text(result.error);
+                    }
+                    workInProgress(false);
+                },
+                error: function (errMsg) {
+                    var txt = log(errMsg);
+                    $("#jsonMessage").text(txt);
+                    workInProgress(false);
+                }
+            });
+            return false;
+        });
+    });
+
+    $('input[name="RemoveNode"]').click(function () {
+        var node = $("#container").dynatree("getActiveNode");
+        if (node && node.data.title !== "Experiment")
+            node.remove();
+        $(this).attr("disabled", "disabled");
+    });
+});
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/dynatree/grunt.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/dynatree/grunt.js	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/dynatree/grunt.js	(revision 9215)
@@ -0,0 +1,80 @@
+/*jslint node:true */
+
+module.exports = function(grunt) {
+    // Project configuration.
+    grunt.initConfig({
+        pkg: "<json:package.json>",
+        // Project metadata, used by the <banner> directive.
+        meta: {
+            banner: "/*! <%= pkg.title || pkg.name %> - v<%= pkg.version %> - " +
+                    "<%= grunt.template.today('yyyy-mm-dd') %>\n" +
+                    "<%= pkg.homepage ? '* ' + pkg.homepage + '\n' : '' %>" +
+                    "* Copyright (c) <%= grunt.template.today('yyyy') %> <%= pkg.author.name %>;" +
+                    " Licensed <%= _.pluck(pkg.licenses, 'type').join(', ') %> */"
+        },
+        concat: {
+            dist: {
+                src: ["<banner:meta.banner>", "<file_strip_banner:src/<%= pkg.name %>.js>"],
+//                src: ["src/jquery.dynatree.js"],
+                dest: "dist/<%= pkg.name %>-<%= pkg.version %>.js"
+            }
+        },
+        min: {
+            dist: {
+                src: ["<banner:meta.banner>", "<config:concat.dist.dest>"],
+                dest: "dist/<%= pkg.name %>.min.js"
+            }
+        },
+//        qunit: {
+//            files: ["tests/unit/**/*.html"]
+//        },
+        lint: {
+//            beforeconcat: ["grunt.js", "src/**/*.js", "tests/**/*.js"],
+            beforeconcat: ["src/jquery.dynatree.js"],
+//            beforeconcat: ["grunt.js"],
+//            beforeconcat: ["grunt.js", "src/jquery.dynatree.js", "tests/**/*.js"],
+            afterconcat: ["<config:concat.dist.dest>"]
+        },
+        // watch: {
+        //   files: "<config:lint.files>",
+        //   tasks: "lint qunit"
+        // },        
+
+        jshint: {
+            options: {
+                // Enforcing Options:
+                bitwise: true,
+                curly: true,
+//              forin: true,
+                eqeqeq: true,
+                immed: true,
+                latedef: true,
+                newcap: true,
+                noarg: true,
+//              noempty: true,
+                nonew: true,
+//              plusplus: true,
+                regexp: true,
+//              strict: true,
+                sub: true,
+                undef: true,
+                // Relaxing Options:
+                eqnull: false,
+                laxbreak: true,
+//                laxcomma: true,
+                smarttabs: false,
+//                globalstrict: true,
+                // Environments:
+//              node: true,  // TODO: only for grunt.js and dynatree-server.json
+                browser: true
+            },
+            globals: {
+                jQuery: true
+            }
+        },
+        uglify: {
+        }
+    });
+    // Default task.
+    grunt.registerTask("default", "lint:beforeconcat concat lint:afterconcat min");
+};
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/AdminController.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/AdminController.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/AdminController.cs	(revision 9215)
@@ -13,4 +13,5 @@
 using System.Web.Security;
 using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Services.Optimization.Web.Helpers;
 
 namespace HeuristicLab.Services.Optimization.Web.Controllers
@@ -19,26 +20,13 @@
     public class AdminController : Controller
     {
-      public delegate T ControllerServiceDelegate<T>(IControllerService service);
-      public delegate void ControllerServiceDelegate(IControllerService service);
-
-      public T withControllerService<T>(ControllerServiceDelegate<T> del) {
-        using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
-          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
-          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
-          credentialBehaviour.UserName.Password = Session["pw"] as string;
-          var controllerProxy = cf.CreateChannel();
-          return del(controllerProxy);
+      private ControllerServiceHelper ControllerService {
+          get {
+            var helper = new ControllerServiceHelper(Session["pw"] as string);
+            if (!helper.Valid) {
+              Response.Redirect("/Account/Logon");
+            }
+            return helper;
+          }
         }
-      }
-
-      public void withControllerService(ControllerServiceDelegate del) {
-        using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
-          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
-          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
-          credentialBehaviour.UserName.Password = Session["pw"] as string;
-          var controllerProxy = cf.CreateChannel();
-          del(controllerProxy);
-        }
-      }
         //
         // GET: /Admin/
@@ -46,5 +34,5 @@
         public ActionResult Index()
         {
-          var names = withControllerService<IEnumerable<string>>((service) => {            
+          var names = ControllerService.withControllerService<IEnumerable<string>>((service) => {            
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
             return service.GetOptimizationScenarioNames();
@@ -68,5 +56,5 @@
           }
 
-          var ok = withControllerService<bool>((service) => {
+          var ok = ControllerService.withControllerService<bool>((service) => {
             OptimizationModel model = new OptimizationModel();
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
@@ -78,5 +66,5 @@
 
         public ActionResult DeleteScenario(string id) {
-          withControllerService<bool>((service) => {            
+          ControllerService.withControllerService<bool>((service) => {            
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
             return service.DeleteHiveScenario(u, id);
